/* define ID of this brick */
#define ID 1
/* define WAIT_TIME in seconds */
#define WAIT_TIME 1

/* include time.h */
#include <time.h>
/* include conio.h */
#include <conio.h>

/* include com.c */
#include "com.c"

/* declare thread id for read_from_ir_thread */
tid_t read_from_ir_thread;
/* declare thread id for send_to_ir_thread */
tid_t send_to_ir_thread; 
/* declare thread id for received_thread */
tid_t received_thread;

/* begin send_to_ir thread */
int send_to_ir (int argc, char *argv[]) {

    /* declare a */
    int a;
    /* declare time */
    time_t time;
    
    /* initialize a */
    a=0;
    
    /* begin while loop */
    while(!shutdown_requested()) {
        /* time = current time*/
        time = get_system_up_time();
        /* a = a + 10 */
        a+=10;
        /* clear user portion screen */
        cls();
        /* show a on lcd */
        lcd_int(a);
        /* refresh lcd */
        lcd_refresh();
        /* sleep of 0.3 seconds */
        msleep(300);
        /* send a from RCX ID to RCX 2 with type 1 */
        com_send(ID,2,1,&a);
        /* time = current time - time (previous obtained) */
        time=get_system_up_time()-time;
        /* sleep untill current loop exceeds WAIT_TIME seconds */
        msleep(WAIT_TIME*TICKS_PER_SEC - time);
    /* end while loop */
    }
    
    /* return 0 */
    return 0;                                   
}

/* begin wait function have */
static wakeup_t have(wakeup_t w) {
    /* return TRIGGER2 */
    return TRIGGER2;
/* end wait function have */
}

/* begin received thread */
int received(int argc, char *argv[]) {

    /* declare a */
    int a;
    /* initialize a */
    a=1;
    
    /* begin while loop */
    while(!shutdown_requested()) {
        /* wait for funcion have */
        wait_event(have,0);
        /* show TRIGGER2 on lcd */
        lcd_int(TRIGGER2);
        /* wait for semaphore key */
        sem_wait(&sem_com);                      
        /* set TRIGGER2 to zero */
        TRIGGER2=0;
        /* post semaphore key */
        sem_post(&sem_com);                      
    /* end while loop */
    }
    
    /* return 0 */
    return 0;
/* end received thread */
}

/* begin main */
int main(int argc, char *argv[]) {

    /* initialize communication port */
    lnp_integrity_set_handler(port_handler);
    /* set ir range to "far" */
    lnp_logical_range(1);
    /* initialize semaphore for communication */
    sem_init(&sem_com, 0, 1);

    /* start read_from_ir thread */
	read_from_ir_thread = execi(&read_from_ir,0,0,PRIO_NORMAL,DEFAULT_STACK_SIZE);
    /* start send_to_ir thread */
    send_to_ir_thread = execi(&send_to_ir,0,0,PRIO_NORMAL,DEFAULT_STACK_SIZE);
    /* start received thread */
    received_thread = execi(&received,0,0,PRIO_NORMAL,DEFAULT_STACK_SIZE);
	
    /* return 0 */
    return 0;
/* end main */
}
